public class AppV2 {

  public static final int MINIMUM_MINISTRO_VERSION = 2;

  public static void main(String... args) throws Exception {
    new AppV2();
  }

  public AppV2() {

    // faked service look-up
    MinistroService service = MinistroService.INSTANCE;

    if (service.isCompatible(MINIMUM_MINISTRO_VERSION)) {
	// Would cause a NoSuchMethodError if called without
        //  the above check.
	service.serve(new Callback2Impl());

    } else {
	System.out.println("go and update Ministro!");
    }
  }

}

class Callback2Impl implements Callback2 {

    public String getApplicationName() { return "App Version 2"; }

    public int getRequiredLoaderLevel() { return 10; }

    public void succeed() { };

    public void fail() { };
}

